#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct LinkedListNodeType {
	int data;
	struct LinkedListNodeType *pLink;
} LinkedListNode;

typedef struct LinkedListType {
    int             currentCount;
    LinkedListNode  headerNode;
} LinkedList;

LinkedList *createLinkedList() {
	LinkedList *pReturn = (LinkedList *)malloc(sizeof(LinkedList));
	if (NULL != pReturn) {
		memset(pReturn, 0, sizeof(LinkedList));
	}
	return pReturn;
}

int getLinkedListData(LinkedList* pList, int position) {
	int i = 0;

	LinkedListNode *pCurrentNode = &(pList->headerNode);
	for (i = 0; i <= position; i++) {
		pCurrentNode = pCurrentNode->pLink;
	}

	return pCurrentNode->data;
}

int addLinkedListData(LinkedList* pList, int position, int data) {
	int ret = 0;
	int i = 0;
	LinkedListNode *pNewNode = NULL;
	LinkedListNode *pPreNode = NULL;

	if (pList != NULL) {
		if (position >= 0 && position <= pList->currentCount) {
			pNewNode = (LinkedListNode*)malloc(sizeof(LinkedListNode));
			if (pNewNode != NULL) {
				pNewNode->data = data;

				pPreNode = &(pList->headerNode);
				for (i = 0; i < position; i++) {
					pPreNode = pPreNode->pLink;
				}

				pNewNode->pLink = pPreNode->pLink;
				pPreNode->pLink = pNewNode;
				pList->currentCount++;
			}
			else {
				ret = 1;
				printf(", ޸Ҵ addLinkedListData()\n");
			}
		}
		else {
			ret = 1;
			printf(", ġ ε-[%d], addLinkedListData()\n", position);
		}
	}
	else {
		ret = 1;
	}
    return ret;
}

int removeLinkedListData(LinkedList* pList, int position) {
	int ret = 0;
	int i = 0;
	LinkedListNode *pDelNode = NULL;
	LinkedListNode *pPreNode = NULL;

	if (pList != NULL) {
		if (position >= 0 && position < pList->currentCount) {
			pPreNode = &(pList->headerNode);
			for (i = 0; i < position; i++) {
				pPreNode = pPreNode->pLink;
			}

			pDelNode = pPreNode->pLink;
			pPreNode->pLink = pDelNode->pLink;
			free(pDelNode);
			pList->currentCount--;
		}
		else {
			ret = 1;
			printf(", ġ ε-[%d], removeLinkedListData()\n", position);
		}
	}
	else {
		ret = 1;
	}
    return ret;
}

void deleteLinkedList(LinkedList* pList) {
	LinkedListNode *pDelNode = NULL;
	LinkedListNode *pPreNode = NULL;
	
	if (pList != NULL) {
		pPreNode = pList->headerNode.pLink;
		while (pPreNode != NULL) {
			pDelNode = pPreNode;
			pPreNode = pPreNode->pLink;

			free(pDelNode);
		}

		free(pList);
	}
}

int getListLength(LinkedList* pList) {
	if (NULL != pList) {
		return pList->currentCount;
	}
	return 0;
}

int getListLength2(LinkedList* pList) {
	int ret = 0;
	if (NULL != pList) {
		LinkedListNode *pPreNode = pList->headerNode.pLink;
		while (pPreNode != NULL) {
			ret++;
			pPreNode = pPreNode->pLink;
		}
	}
	return ret;
}

int main(int argc, char *argv[]) {
	LinkedList *pList = NULL;
	int value = 0;

	pList = createLinkedList();
	addLinkedListData(pList, 0, 10);
	addLinkedListData(pList, 1, 20);
	addLinkedListData(pList, 1, 30);

	value = getLinkedListData(pList, 1);
	printf("ġ: %d, : %d\n", 1, value);

	value = getListLength(pList);
	printf("ڷ : %d\n", value);

	value = getListLength2(pList);
	printf("ڷ : %d\n", value);

	removeLinkedListData(pList, 1);
	deleteLinkedList(pList);

	return 0;
}
