#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct LinkedListNodeType {
	int data;
	struct LinkedListNodeType *pLink;
} LinkedListNode;

typedef struct LinkedListType {
	int             currentCount;
    LinkedListNode  headerNode;
} LinkedList;

LinkedList *createLinkedList() {
	LinkedList *pReturn = (LinkedList *)malloc(sizeof(LinkedList));
	memset(pReturn, 0, sizeof(LinkedList));
	return pReturn;
}

int getLinkedListData(LinkedList* pList, int position) {
	int i = 0;

	LinkedListNode *pCurrentNode = &(pList->headerNode);
	for (i = 0; i <= position; i++) {
		pCurrentNode = pCurrentNode->pLink;
	}

	return pCurrentNode->data;
}

int addLinkedListData(LinkedList* pList, int position, int data) {
	int i = 0;
	LinkedListNode *pNewNode = NULL;
	LinkedListNode *pPreNode = NULL;

	pNewNode = (LinkedListNode*)malloc(sizeof(LinkedListNode));
	pNewNode->data = data;

	pPreNode = &(pList->headerNode);
	for (i = 0; i < position; i++) {
		pPreNode = pPreNode->pLink;
	}

	pNewNode->pLink = pPreNode->pLink;
	pPreNode->pLink = pNewNode;
	pList->currentCount++;
    return 0;
}

int removeLinkedListData(LinkedList* pList, int position) {
	int i = 0;
	LinkedListNode *pDelNode = NULL;
	LinkedListNode *pPreNode = NULL;

	pPreNode = &(pList->headerNode);
	for (i = 0; i < position; i++) {
		pPreNode = pPreNode->pLink;
	}

	pDelNode = pPreNode->pLink;
	pPreNode->pLink = pDelNode->pLink;
	free(pDelNode);
	pList->currentCount--;
    return 0;
}

void deleteLinkedList(LinkedList* pList) {
	LinkedListNode *pDelNode = NULL;
	LinkedListNode *pPreNode = pList->headerNode.pLink;
	while (pPreNode != NULL) {
		pDelNode = pPreNode;
		pPreNode = pPreNode->pLink;

		free(pDelNode);
	}

	free(pList);
}

int getLinkedListLength(LinkedList* pList) {
	if (NULL != pList) {
		return pList->currentCount;
	}
	return 0;
}

void iterateLinkedList(LinkedList* pList)
{
	int count = 0;
	LinkedListNode* pNode = NULL;

	pNode = pList->headerNode.pLink;
	while (pNode != NULL) {
		printf("[%d],%d\n", count, pNode->data);
		count++;

		pNode = pNode->pLink;
	}
	printf(" : %d\n", count);
}

int main(int argc, char *argv[]) {
	LinkedList *pList = NULL;
	double value = 0, sum = 0;
	int position = 0, i = 0;

	pList = createLinkedList();

	do {
		printf("%d° (-1 Էϸ ϴ)?  ", (position + 1));
		scanf_s("%lf", &value);

		if (value != -1) {
			addLinkedListData(pList, position, value);
			position++;
		}
	} while (value != -1);

	if (position > 0) {
		for (i = 0; i < position; i++) {
			sum += getLinkedListData(pList, i);
		}
		printf("%d  : %.3f\n", position, (sum / position));
	}
	else {
		printf("1 ̻  Էؾ մϴ\n");
	}

	deleteLinkedList(pList);

	return 0;
}
