#include <stdio.h>
#include <stdlib.h>
#include <string.h>
typedef struct DequeNodeType
{
	char data;
	struct DequeNodeType* pRLink;
	struct DequeNodeType* pLLink;
} DequeNode;

typedef struct LinkedDequeType
{
	int currentElementCount;		//   
	DequeNode* pFrontNode;		// Front  
	DequeNode* pRearNode;		// Rear  
} LinkedDeque;
LinkedDeque* createLinkedDeque()
{
	LinkedDeque *pReturn = NULL;
	int i = 0;

	pReturn = (LinkedDeque *)malloc(sizeof(LinkedDeque));
	if (pReturn != NULL) {
		memset(pReturn, 0, sizeof(LinkedDeque));
	}
	else {
		printf(", ޸ Ҵ, createLinkedDeque()\n");
		return NULL;
	}

	return pReturn;
}

int insertFrontLD(LinkedDeque* pDeque, DequeNode element)
{
	int ret = 0;
	DequeNode *pNode = NULL;

	if (pDeque != NULL) {
		pNode = (DequeNode *)malloc(sizeof(DequeNode));
		if (pNode != NULL) {
			*pNode = element;
			pNode->pRLink = NULL;
			pNode->pLLink = NULL;

			if (isLinkedDequeEmpty(pDeque) == 1) {
				pDeque->pFrontNode = pNode;
				pDeque->pRearNode = pNode;
			}
			else {
				pDeque->pFrontNode->pLLink = pNode;
				pNode->pRLink = pDeque->pFrontNode;
				pDeque->pFrontNode = pNode;
			}
			pDeque->currentElementCount++;
			ret = 1;
		}
		else {
			printf(",޸ Ҵ,insertFrontLD()\n");
		}
	}

	return ret;
}

int insertRearLD(LinkedDeque* pDeque, DequeNode element)
{
	int ret = 0;
	DequeNode *pNode = NULL;

	if (pDeque != NULL) {
		pNode = (DequeNode *)malloc(sizeof(DequeNode));
		if (pNode != NULL) {
			*pNode = element;
			pNode->pRLink = NULL;
			pNode->pLLink = NULL;

			if (isLinkedDequeEmpty(pDeque) == 1) {
				pDeque->pFrontNode = pNode;
				pDeque->pRearNode = pNode;
			}
			else {
				pDeque->pRearNode->pRLink = pNode;
				pNode->pLLink = pDeque->pRearNode;
				pDeque->pRearNode = pNode;
			}
			pDeque->currentElementCount++;
			ret = 1;
		}
		else {
			printf(",޸ Ҵ,insertRearLD()\n");
		}
	}

	return ret;
}

DequeNode* deleteFrontLD(LinkedDeque* pDeque)
{
	DequeNode* pReturn = NULL;
	if (pDeque != NULL) {
		if (isLinkedDequeEmpty(pDeque) == 0) {
			pReturn = pDeque->pFrontNode;
			pDeque->pFrontNode = pDeque->pFrontNode->pRLink;
			pReturn->pRLink = NULL;

			pDeque->currentElementCount--;
			if (isLinkedDequeEmpty(pDeque) == 1) {
				pDeque->pRearNode = NULL;
			}
			else {
				pDeque->pFrontNode->pLLink = NULL;
			}
		}
	}

	return pReturn;
}

DequeNode* peekFrontLD(LinkedDeque* pDeque)
{
	DequeNode* pReturn = NULL;
	if (pDeque != NULL) {
		if (isLinkedDequeEmpty(pDeque) == 0) {
			pReturn = pDeque->pFrontNode;
		}
	}

	return pReturn;
}

DequeNode* deleteRearLD(LinkedDeque* pDeque)
{
	DequeNode* pReturn = NULL;
	if (pDeque != NULL) {
		if (isLinkedDequeEmpty(pDeque) == 0) {
			pReturn = pDeque->pRearNode;
			pDeque->pRearNode = pDeque->pRearNode->pLLink;
			pReturn->pLLink = NULL;

			pDeque->currentElementCount--;
			if (isLinkedDequeEmpty(pDeque) == 1) {
				pDeque->pFrontNode = NULL;
			}
			else {
				pDeque->pRearNode->pRLink = NULL;
			}
		}
	}

	return pReturn;
}

DequeNode* peekRearLD(LinkedDeque* pDeque)
{
	DequeNode* pReturn = NULL;
	if (pDeque != NULL) {
		if (isLinkedDequeEmpty(pDeque) == 0) {
			pReturn = pDeque->pRearNode;
		}
	}

	return pReturn;
}

void deleteLinkedDeque(LinkedDeque* pDeque)
{
	DequeNode *pNode = NULL;
	DequeNode *pDelNode = NULL;

	if (pDeque != NULL) {
		pNode = pDeque->pFrontNode;
		while (pNode != NULL) {
			pDelNode = pNode;
			pNode = pNode->pRLink;
			free(pDelNode);
		}
		free(pDeque);
	}
}

int isLinkedDequeFull(LinkedDeque* pDeque)
{
	int ret = 0;
	return ret;
}

int isLinkedDequeEmpty(LinkedDeque* pDeque)
{
	int ret = 0;
	if (pDeque != NULL) {
		if (pDeque->currentElementCount == 0) {
			ret = 1;
		}
	}

	return ret;
}

int insertFrontLDChar(LinkedDeque* pDeque, char data)
{
	DequeNode node = { 0, };
	node.data = data;
	return insertFrontLD(pDeque, node);
}

int insertRearLDChar(LinkedDeque* pDeque, char data)
{
	DequeNode node = { 0, };
	node.data = data;
	return insertRearLD(pDeque, node);
}

void displayLinkedDeque(LinkedDeque *pDeque)
{
	DequeNode *pNode = NULL;
	int i = 0;

	if (pDeque != NULL) {
		printf("  : %d\n",
			pDeque->currentElementCount);
		pNode = pDeque->pFrontNode;
		while (pNode != NULL) {
			printf("[%d]-[%c]\n", i, pNode->data);
			i++;
			pNode = pNode->pRLink;
		}
	}
}

int main(int argc, char *argv[])
{
	LinkedDeque *pDeque = NULL;
	DequeNode *pNode = NULL;

	pDeque = createLinkedDeque();
	if (pDeque != NULL) {
		insertFrontLDChar(pDeque, 'A');
		insertFrontLDChar(pDeque, 'B');
		insertRearLDChar(pDeque, 'C');
		insertRearLDChar(pDeque, 'D');
		displayLinkedDeque(pDeque);

		pNode = deleteRearLD(pDeque);
		if (pNode != NULL) {
			printf("deleteRearLD Value-[%c]\n", pNode->data);
			free(pNode);
		}
		displayLinkedDeque(pDeque);

		pNode = deleteFrontLD(pDeque);
		if (pNode != NULL) {
			printf("deleteFrontLD Value-[%c]\n", pNode->data);
			free(pNode);
		}
		displayLinkedDeque(pDeque);

		deleteLinkedDeque(pDeque);
	}
	return 0;
}
