#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "bintree.h"
#include "bintreelinkedqueue.h"

BinTree* createExampleBinTree();
void levelOrderTraversalBinTree(BinTree *pBinTree);

int main(int argc, char *argv[])
{
	BinTree *pBinTree = createExampleBinTree();
	if (pBinTree != NULL) {
		printf(" ȸ : \n");
		levelOrderTraversalBinTree(pBinTree);

		deleteBinTree(pBinTree);
	}

	return 0;
}

void levelOrderTraversalBinTree(BinTree *pBinTree)
{
	LinkedQueue* pQueue = NULL;
	LinkedQueueNode* pLinkedQueueNode = NULL;

	BinTreeNode *pCurrentNode = NULL;

	if (pBinTree == NULL) {
		return;
	}
	pCurrentNode = getRootNodeBT(pBinTree);
	if (pCurrentNode == NULL) {
		return;
	}
	pQueue = createLinkedQueue();
	if (pQueue == NULL) {
		return;
	}
	enqueueLQ(pQueue, pCurrentNode);
	while (1) {
		if (isLinkedQueueEmpty(pQueue)) {
			return;
		}
		else {
			pLinkedQueueNode = dequeueLQ(pQueue);
			if (pLinkedQueueNode != NULL) {
				pCurrentNode = pLinkedQueueNode->data;

				if (pCurrentNode != NULL) {
					printf("%c ", pCurrentNode->data);
				}
				if (pCurrentNode->pLeftChild != NULL) {
					enqueueLQ(pQueue, pCurrentNode->pLeftChild);
				}
				if (pCurrentNode->pRightChild != NULL) {
					enqueueLQ(pQueue, pCurrentNode->pRightChild);
				}

				free(pLinkedQueueNode);
			}
		}
	}
	deleteLinkedQueue(pQueue);
}

BinTree* createExampleBinTree()
{
	BinTree* pReturn = NULL;
	BinTreeNode *pNodeA = NULL, *pNodeB = NULL, *pNodeC = NULL;
	BinTreeNode *pNodeD = NULL, *pNodeE = NULL, *pNodeF = NULL;
	BinTreeNode *pNodeG = NULL, *pNodeH = NULL, *pNodeI = NULL;
	//BinTreeNode *pNodeJ = NULL, *pNodeK = NULL, *pNodeL = NULL;

	pReturn = makeBinTree('A');
	if (pReturn != NULL) {
		pNodeA = getRootNodeBT(pReturn);
		pNodeB = addLeftChildNodeBT(pNodeA, 'B');
		pNodeC = addRightChildNodeBT(pNodeA, 'C');
		if (pNodeB != NULL) {
			pNodeD = addLeftChildNodeBT(pNodeB, 'D');
			pNodeE = addRightChildNodeBT(pNodeB, 'E');
		}
		if (pNodeD != NULL) {
			addLeftChildNodeBT(pNodeD, 'H');
			addRightChildNodeBT(pNodeD, 'I');
		}
		if (pNodeE != NULL) {
			addLeftChildNodeBT(pNodeE, 'J');
		}
		if (pNodeC != NULL) {
			pNodeF = addLeftChildNodeBT(pNodeC, 'F');
			pNodeG = addRightChildNodeBT(pNodeC, 'G');
		}
		if (pNodeF != NULL) {
			addRightChildNodeBT(pNodeE, 'K');
		}
		if (pNodeG != NULL) {
			addLeftChildNodeBT(pNodeG, 'L');
			addRightChildNodeBT(pNodeG, 'M');
		}
	}

	return pReturn;
}
