#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct HeapNodeType
{
	int data;
} HeapNode;

typedef struct ArrayHeapType
{
	int maxCount;           // ִ  
	int currentCount;       //   
	HeapNode *pData;		//    1 array
} ArrayMaxHeap, ArrayMinHeap;

ArrayMaxHeap* createArrayMaxHeap(int maxCount)
{
	ArrayMaxHeap *pReturn = NULL;
	if (maxCount > 0) {
		pReturn = (ArrayMaxHeap *)malloc(sizeof(ArrayMaxHeap));
		if (pReturn != NULL) {
			pReturn->maxCount = maxCount;
			pReturn->currentCount = 0;
			pReturn->pData = (HeapNode *)malloc(sizeof(HeapNode) * (maxCount + 1));
			if (pReturn->pData != NULL) {
				memset(pReturn->pData, 0, sizeof(HeapNode) * (maxCount + 1));
			}
			else {
				printf(", 2° ޸ Ҵ, createArrayMaxHeap()\n");
				free(pReturn);
				return NULL;
			}
		}
		else {
			printf(", ޸ Ҵ, createArrayMaxHeap()\n");
		}
	}
	else {
		printf("ִ   0 Ŀ մϴ\n");
	}

	return pReturn;
}

int insertMaxHeapAH(ArrayMaxHeap* pHeap, int value)
{
	int i = 0;

	if (pHeap != NULL) {
		if (pHeap->currentCount == pHeap->maxCount) {
			printf(",  áϴ[%d],insertMaxHeapAH()\n",
				pHeap->maxCount);
			return 0;
		}

		pHeap->currentCount++;
		i = pHeap->currentCount;
		while ((i != 1) && (value > pHeap->pData[i / 2].data)) {
			pHeap->pData[i] = pHeap->pData[i / 2];
			i /= 2;
		}
		pHeap->pData[i].data = value;
	}

	return i;
}

HeapNode* deleteMaxHeapAH(ArrayMaxHeap* pHeap)
{
	HeapNode* pReturn = NULL;
	HeapNode* pTemp = NULL;
	int parent = 1, child = 2;

	if (pHeap != NULL && pHeap->currentCount >  0) {
		pReturn = (HeapNode*)malloc(sizeof(HeapNode));
		if (pReturn == NULL) {
			printf(", ޸ Ҵ, deleteMaxHeapAH()\n");
			return NULL;
		}
		pReturn->data = pHeap->pData[1].data;

		pTemp = &(pHeap->pData[pHeap->currentCount]);
		pHeap->currentCount--;

		while (child <= pHeap->currentCount) {
			if ((child < pHeap->currentCount)
				&& pHeap->pData[child].data < pHeap->pData[child + 1].data) {
				child++;
			}
			if (pTemp->data >= pHeap->pData[child].data) {
				break;
			}

			pHeap->pData[parent] = pHeap->pData[child];
			parent = child;
			child *= 2;
		}// end-of-while
		pHeap->pData[parent] = *pTemp;
	}

	return pReturn;
}

void deleteArrayMaxHeap(ArrayMaxHeap* pHeap)
{
	if (pHeap != NULL) {
		if (pHeap->pData != NULL) {
			free(pHeap->pData);
		}
		free(pHeap);
	}
}


void displayArrayHeap(ArrayMaxHeap* pHeap)
{
	int i = 0;
	if (pHeap != NULL) {
		for (i = 1; i <= pHeap->currentCount; i++) {
			printf("[%d],%d\n", i, pHeap->pData[i].data);
		}
	}
}

// ּ  
ArrayMinHeap* createArrayMinHeap(int maxCount)
{
	return createArrayMaxHeap(maxCount);
}

// ּ  
void deleteArrayMinHeap(ArrayMinHeap* pHeap)
{
	deleteArrayMaxHeap(pHeap);
}

// ּ  
void insertMinHeapAH(ArrayMinHeap* pHeap, int value)
{
	int i = 0;

	if (pHeap != NULL) {
		if (pHeap->currentCount == pHeap->maxCount) {
			printf("Error, heap is full [%d],insertMinHeapAH()\n",
				pHeap->maxCount);
			return;
		}

		pHeap->currentCount++;
		i = pHeap->currentCount;
		while ((i != 1) && (value < pHeap->pData[i / 2].data)) {
			pHeap->pData[i] = pHeap->pData[i / 2];
			i /= 2;
		}
		pHeap->pData[i].data = value;
	}
}

// ּ  
HeapNode* deleteMinHeapAH(ArrayMinHeap* pHeap)
{
	HeapNode* pReturn = NULL;
	HeapNode* pTemp = NULL;

	int i = 0;
	int parent = 0, child = 0;

	if (pHeap != NULL && pHeap->currentCount >  0) {
		pReturn = (HeapNode*)malloc(sizeof(HeapNode));
		if (pReturn == NULL) {
			printf("Error, malloc() in deleteMinHeapAH()\n");
			return NULL;
		}
		*pReturn = pHeap->pData[1];

		i = pHeap->currentCount;
		pTemp = &(pHeap->pData[i]);
		pHeap->currentCount--;

		parent = 1;
		child = 2;
		while (child <= pHeap->currentCount) {
			if ((child < pHeap->currentCount)
				&& pHeap->pData[child].data > pHeap->pData[child + 1].data) {
				child++;
			}
			if (pTemp->data <= pHeap->pData[child].data) {
				break;
			}

			pHeap->pData[parent] = pHeap->pData[child];
			parent = child;
			child *= 2;
		}
		pHeap->pData[parent] = *pTemp;
	}

	return pReturn;
}

int main(int argc, char *argv[])
{
	int minHeapSize = 20;
	ArrayMinHeap *pHeap1 = NULL;
	HeapNode *pNode = NULL;

	pHeap1 = createArrayMinHeap(minHeapSize);
	if (pHeap1 != NULL) {
		insertMinHeapAH(pHeap1, 10);
		insertMinHeapAH(pHeap1, 20);
		insertMinHeapAH(pHeap1, 60);
		insertMinHeapAH(pHeap1, 15);
		insertMinHeapAH(pHeap1, 35);
		insertMinHeapAH(pHeap1, 45);
		insertMinHeapAH(pHeap1, 25);
		insertMinHeapAH(pHeap1, 20);

		printf("Min Heap:\n");
		displayArrayHeap(pHeap1);

		pNode = deleteMinHeapAH(pHeap1);
		if (pNode != NULL) {
			printf("deleteMinHeapAH()-[%d]\n", pNode->data);
			free(pNode);
		}

		printf("Min Heap:\n");
		displayArrayHeap(pHeap1);

		pNode = deleteMinHeapAH(pHeap1);
		if (pNode != NULL) {
			printf("deleteMinHeapAH()-[%d]\n", pNode->data);
			free(pNode);
		}

		printf("Min Heap:\n");
		displayArrayHeap(pHeap1);

		deleteArrayMaxHeap(pHeap1);
	}

	return 0;
}
