#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "linkedstack.h"
#include "arraygraph.h"

// DFS ׷ Ž
void traversalDFS(ArrayGraph* pGraph, int startNodeID)
{
	int i = 0;
	int nodeID = 0;
	LinkedStack* pStack = NULL;
	LinkedStackNode* pStackNode = NULL;
	//ListNode *pListNode = NULL;
	int *pVisited = NULL;

	if (pGraph == NULL) {
		return;
	}

	pStack = createLinkedStack();
	if (pStack == NULL) {
		return;
	}

	pVisited = (int*)malloc(sizeof(int) * pGraph->nodeCount);
	if (pVisited == NULL) {
		printf("Error, malloc() in traversalDFS()\n");
		return;
	}

	// ʱȭ.
	for (i = 0; i < pGraph->nodeCount; i++) {
		pVisited[i] = 0;
	}

	pushLS(pStack, startNodeID);
	pVisited[startNodeID] = 1;

	while (isLinkedStackEmpty(pStack) == 0) {
		pStackNode = popLS(pStack);
		if (pStackNode != NULL) {
			nodeID = pStackNode->data;
			printf("[%d]-visited\n", nodeID);

			for (i = pGraph->nodeCount - 1; i >= 0; i--) {
				if (i != nodeID) {
					if (0 != getEdgeAG(pGraph, nodeID, i)) {
						if (0 == pVisited[i]) {
							pVisited[i] = 1;
							pushLS(pStack, i);
						}
					}
				}
			}

			free(pStackNode);
		}
	}

	free(pVisited);
	deleteLinkedStack(pStack);
}

int main(int argc, char *argv[])
{
    int nodeCount = 4;
    ArrayGraph *pG1 = createArrayGraph(ARRAY_GRAPH_TYPE_UNDIRECT, nodeCount);
    
    if (pG1 != NULL) {
        addEdgeAG(pG1, 0, 1);
        addEdgeAG(pG1, 0, 2);
        addEdgeAG(pG1, 1, 3);

        printf("G1: DFS\n");
        traversalDFS(pG1, 0);
        
        deleteGraphAG(pG1);
    }
    
    return 0;
}
